﻿Imports System.ComponentModel.Design
Imports EventBindings.Extensions
Namespace Design
    Public Class EventBindingBox

#Region "Fields"
        Private _BindingSources As ComboBoxController(Of IEventBindingSource)
        Private _Binding As EventBinding
        Private _ChangeService As IComponentChangeService
#End Region

#Region "Events"
        Public Event DataChanged As EventHandler
#End Region

#Region "Constructor"
        Public Sub New()

            ' Cet appel est requis par le concepteur.
            InitializeComponent()

            ' Ajoutez une initialisation quelconque après l'appel InitializeComponent().
            Me._BindingSources = New ComboBoxController(Of IEventBindingSource)(Me.cbbBindingSources, AddressOf OnBindingSourceChanged)
        End Sub
#End Region

#Region "Methods"
        Private Sub RaiseDataChanged()
            RaiseEvent DataChanged(Me, EventArgs.Empty)
        End Sub
        Public Sub Fill(ByVal binding As EventBinding, ByVal provider As IEventBindingServiceProvider)
            If binding Is Nothing Then Throw New ArgumentNullException("binding")

            Me._ChangeService = provider.GetService(Of IComponentChangeService)()
            Me._Binding = binding
            Me.HandlingDataBox.Fill(Me._Binding, provider)
            Me.MediationDataBox.Fill(Me._Binding, provider)
            Me._BindingSources.ReferenceService = provider.GetService(Of IReferenceService)()
            Me._BindingSources.Items = provider.BindingSources
            Me._BindingSources.SelectedItem = Me._Binding.Source
        End Sub
#End Region

#Region "Event Handlers"    
        Private Sub OnBindingSourceChanged(ByVal value As IEventBindingSource)
            Me._Binding.Source = value
            If value IsNot Nothing AndAlso value IsNot Nothing AndAlso Me._ChangeService IsNot Nothing Then
                Me._ChangeService.OnComponentChanged(value, Nothing, Nothing, Nothing)
            End If
            Me.RaiseDataChanged()
        End Sub
        Private Sub DataBoxes_DataChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HandlingDataBox.DataChanged, MediationDataBox.DataChanged
            Me.MediationDataBox.RefreshWarning()
            Me.HandlingDataBox.RefreshWarning()
            Me.RaiseDataChanged()
        End Sub
#End Region

        
    End Class
End Namespace

