﻿Namespace Design

    Public Class ComboBoxController(Of TItem)
        Inherits ListControlController(Of TItem, ComboBox)

        Public Sub New(ByVal comboBox As ComboBox)
            MyBase.New(comboBox)
        End Sub
        Public Sub New(ByVal comboBox As ComboBox, ByVal selectionHandler As Action(Of TItem))
            MyBase.New(comboBox, selectionHandler)
        End Sub

        Protected Overrides Sub FillControl()
            Me._ListControl.Items.Clear()
            If Me._Items Is Nothing Then Exit Sub
            For Each Item In Me._Items
                Me._ListControl.Items.Add(Item)
            Next
            Me._ListControl.SelectedItem = Me._SelectedItem
        End Sub
        Protected Overrides Sub SetControlSelection()
            Me._ListControl.SelectedItem = Me._SelectedItem
        End Sub
        Protected Overrides Function GetSelectedItem() As TItem
            If Me._ListControl.SelectedItem Is Nothing Then Return Nothing
            Return DirectCast(Me._ListControl.SelectedItem, TItem)
        End Function
    End Class

End Namespace

