﻿Namespace Extensions
    <Extension()>
    Public Module ControlExtensions

#Region "TreeNode"
        <Extension()>
        Public Function FindTagFromAncestors(Of TTag)(ByVal N As TreeNode) As TTag
            If N Is Nothing Then Return Nothing
            If TypeOf N.Tag Is TTag Then Return DirectCast(N.Tag, TTag)
            If N.Parent Is Nothing Then Return Nothing
            Return FindTagFromAncestors(Of TTag)(N.Parent)
        End Function
#End Region

#Region "TreeNodeCollection"
        <Extension()>
        Public Function GetCheckedNodesIncludingChildrenNodes(ByVal NODES As TreeNodeCollection) As IEnumerable(Of TreeNode)
            Dim CheckedNodes As New List(Of TreeNode)
            For Each Node As TreeNode In NODES
                If Node.Checked Then CheckedNodes.Add(Node)
                If Node.Nodes.Count > 0 Then
                    Dim CheckedChildren = GetCheckedNodesIncludingChildrenNodes(Node.Nodes)
                    CheckedNodes.AddRange(CheckedChildren)
                End If
            Next
            Return CheckedNodes
        End Function
#End Region

    End Module
End Namespace

